﻿package com.actionsnippet.qbox.editor{
	
	import flash.display.*
	import flash.events.*;
	import flash.filters.*;
	import flash.geom.*;
	
	public class CreatorObject extends Sprite {
		
		private var _code:String;
 
		public var type:String;
		public var data:Object;
		
		public var shapeData:Object;
		 
		public function CreatorObject(type:String=""){
			this.type = type;
			 data = new Object();
			 shapeData = new Object();
			 shapeData.density = "1";
		}
		 
		protected function format2D(a:Array):String{
			var str:String = "[";
			for (var i:int = 0; i<a.length; i++){
				str += "[" + a[i].toString() + "],";
			}
			str = str.substr(0, str.length-1);
			str += "]";
			return str;
		}		
		public function varName():String{
			//name = name.replace(/instance/g, "auto");
			if (name.indexOf("instance") != -1){
				if (parent){
				    for (var i:int=0; i<parent.numChildren; i++){
						if (parent.getChildAt(i) == this){
							name = "auto" + i;
							break;
						}
					}
				}
			}
			return "var " + name + ":QuickObject = ";
		}
     	public function get objectDef():String{
			var i:int;
			if (type == "Box"){
				 data = {x:Calc.bSize(x), y:Calc.bSize(y), width:Calc.bSize(shapeData.width), height:Calc.bSize(shapeData.height), angle: Calc.bAngle(rotation), density:shapeData.density};
				 return  varName() + "sim.addBox({x:" + data.x + ", y:" + data.y + ", width:" + data.width + ", height:" + data.height + ", angle: "+ data.angle + ", density:"+ data.density+"});";
			}else
			if (type == "Circle"){
				 data = {x:Calc.bSize(x), y:Calc.bSize(y), radius:Calc.bSize(width / 2), density:shapeData.density};
				 return  varName() + "sim.addCircle({x:" + data.x + ", y:" + data.y + ", radius:" + data.radius + ", density:"+ data.density+"});";
			}else 
			if (type == "Poly"){
				var copy:Array  = [];
				for (i = 0; i<shapeData.verts.length; i++){
					copy[i] = shapeData.verts[i].concat();
				}
				data = {x:Calc.bSize(x), y:Calc.bSize(y), verts:format2D(Calc.bSize2DArray(copy)), density:shapeData.density,  angle: Calc.bAngle(rotation)};
				 return  varName() + "sim.addPoly({x:" + data.x + ", y:" + data.y + ", verts:" + data.verts + ", angle: "+ data.angle + ", density:"+ data.density+"});";
			}else
			if (type == "Joint"){
				var bodyA:String;
				var bodyB:String;
				var pntA:Point = localToGlobal(shapeData.pointA)
				var pntB:Point = localToGlobal(shapeData.pointB);
				if (parent){
					for (i = 0; i<parent.numChildren; i++){
						var e:* = parent.getChildAt(i);
						if (e is CreatorObject){
							if (e.type != "Joint"){
								if (e.hitTestPoint(pntA.x, pntA.y, true)){
									  bodyA = e.name +".body";
									 // trace("body A : " + bodyA);
								}else
								if (e.hitTestPoint(pntB.x, pntB.y, true)){
									  bodyB = e.name +".body";
									 // trace("body B : " + bodyB);
								}
								//trace("check collide", e.type);
							}
						}
					}
				}
				data = {a:bodyA, b:bodyB, vecA:"new b2Vec2(" + Calc.bSize(pntA.x) + ", "+ Calc.bSize(pntA.y)+ ")", vecB:"new b2Vec2(" + Calc.bSize(pntB.x) + ", "+ Calc.bSize(pntB.y)+ ")"};
				return  varName() + "sim.addJoint({a:" + data.a + ", b:" + data.b + ", vecA:" + data.vecA + ", vecB:"+ data.vecB+"});";
			}
			return null;
		}
		public function createFromObject(nm:String, obj:Object):void{
			
		}
	}
}