﻿package com.actionsnippet.qbox.editor{
	
	
	import flash.display.*
	import flash.events.*;
	import flash.filters.*;
	import flash.geom.*;
	import flash.ui.Keyboard; 
	import flash.net.*;
	
	import com.actionsnippet.qbox.editor.*;
	import com.actionsnippet.qbox.editor.modes.*;
	import com.actionsnippet.qbox.editor.ui.*;
	
	import com.actionsnippet.utils.Keys; 
	
	
	public class DrawingCreator {
		
		private var _main:MovieClip;
		private var _mode:IDrawMode;
		private var _current:ModeChanger;
 
		private var _modifiers:Object;
		
		private var _shape:CreatorObject;
		private var _propPanel:PropertiesPanel;
		
		private var _loc:Shape;
		
		public function get main():MovieClip{
			return _main;
		}
		
		public function get mode():String {
			return _current.mode.toString();
		}
		
		public function get modifiers():Object{
			return _modifiers;
		}
		
		public function get shape():CreatorObject{
			return _shape;
		}
		
		public function DrawingCreator(main:MovieClip){
			 _main = main;
			 _modifiers = new Object();
			 _modifiers["grid snapping"] = true;
			 
			 _current = new ModeChanger();
			 
			 var grid:Grid = new Grid();
			_main.addChild(grid);
			
			_loc = new Shape();
			_loc.graphics.beginFill(0xFF0000);
			_loc.graphics.drawCircle(0,0,2);
			_main.addChild(_loc);
			
			_propPanel = new PropertiesPanel();
			_propPanel.visible = false;
			_propPanel.addEventListener("name changed", onShapeNameChange);
			_propPanel.addEventListener("density changed", onShapeNameChange);
			
			 _main.addChild(_propPanel);
			 _main.stage.addEventListener(KeyboardEvent.KEY_DOWN, onKeyPressed);
			 _main.stage.addEventListener(KeyboardEvent.KEY_UP, onKeyReleased);
			 _main.stage.addEventListener(MouseEvent.MOUSE_DOWN, onDown);
			 _main.stage.addEventListener(MouseEvent.MOUSE_UP, onUp);
			 
			 _main.addEventListener("created", onCreated);
			 _main.addEventListener(Event.ENTER_FRAME, onMoveLoc);
		}
		private function onMoveLoc(evt:Event):void{
			if (_modifiers["grid snapping"]){
				_loc.x = int(_main.mouseX / 10) * 10;
				_loc.y = int(_main.mouseY / 10) * 10;
				_loc.visible = true;
			}else{
				_loc.visible = false;
			}
		}
		private function onShapeNameChange(evt:Event):void {
			 
			if (_shape){
				_shape.name =  _propPanel.shapeName;
				_shape.shapeData.density = _propPanel.density;
			}
		}
		private function onCreated(evt:Event):void{
			setCurrentShape(evt.target);
		}
		
		private function onRun(evt:Event):void {
			_current.mode.run();
		}
		
		private function onUp(evt:MouseEvent):void {
			_current.mode.end();
			_main.removeEventListener(Event.ENTER_FRAME, onRun);
			_main.stopDrag();
			if (_current.mode.toString() == "Drag"){
			if (_shape){
				if (_modifiers["grid snapping"]){
					var b:Rectangle = _shape.getRect(_main);
					// check rotation
					while(int(b.left) % 10 != 0){
						_shape.x -= 1;
						b = _shape.getRect(_main);
					}
					while(int(b.top) % 10 != 0){
						_shape.y -= 1;
						b = _shape.getRect(_main);
					}
				   // _shape.x = int(_shape.x / 10) * 10;
					//_shape.y = int(_shape.y / 10) * 10;
				}
			}
			}
		}
		
		private function onDown(evt:MouseEvent):void{
			if (evt.target is CreatorObject){
			  setCurrentShape(evt.target);
			} 
			
			if (_current.mode.toString() == "Drag"){
				if (_shape){
					if (_shape.hitTestPoint(_main.mouseX, _main.mouseY, true)){
					_current.mode.start(this);
				    _main.addEventListener(Event.ENTER_FRAME, onRun);
					
					_shape.startDrag();
					_shape.parent.addChild(_shape);
					}
				}
			}else if (_current.mode.toString() == "Rotate"){
				if (_shape){
					_current.mode.start(this);
				   _main.addEventListener(Event.ENTER_FRAME, onRun);
				} 
			}else{
				//
				_current.mode.start(this);
				_main.addEventListener(Event.ENTER_FRAME, onRun);
			}
		}
		private function setCurrentShape(sp:Object):void{
			if(_shape){
				_shape.filters=[]
			}
			_shape = sp as CreatorObject;
			
			if (_shape){
			  _shape.filters = [new GlowFilter()];
			  _propPanel.enabled = true;
			       _propPanel.density = _shape.shapeData.density;
				  _propPanel.shapeName = _shape.name;
			 
			}
		}
		
		private var req:URLRequest;
		
		private function onKeyPressed(evt:KeyboardEvent):void{
			 var code:int = evt.keyCode;
			 if (code == Keys.I){
				_propPanel.visible = !_propPanel.visible;  
				_main.addChild(_propPanel);
			 } else 
			 if (code == Keys.ONE){
				_current.change(new SaveMode(this, readCodeFromObjects()));
			 }else if (code == Keys.TWO){
				 _current.change(new LoadMode(this));
			 }else if (code == Keys.THREE){
				req = new URLRequest();
				req.url="preview.swf";
				
				req.data = "data=" + readCodeFromObjects();
				req.method = URLRequestMethod.GET;
				navigateToURL(req); 
			 }else if (code == Keys.FOUR){
				req = new URLRequest();
				req.url="preview.swf";
				
				req.data = "debug=true&data=" + readCodeFromObjects();
				req.method = URLRequestMethod.GET;
				navigateToURL(req); 
			 }
			 if (_propPanel.visible == true) {
				 _current.change(new DrawingMode());
				 return
			 }
			 
			 if (code == Keys.A){
				  _current.change(new DrawingMode());
			 }else
			 if (code == Keys.B){
				 _current.change(new BoxMode());
			 }else if (code == Keys.C){
				 _current.change(new CircleMode()); 
			 }else if (code == Keys.P){
				 _current.change(new PolyMode()); 
			 }else if (code == Keys.D){
				 _current.change(new DragMode());
			 }else if (code == Keys.R){
				  _current.change(new RotateMode());
			 }else if (code == Keys.J){
				  _current.change(new JointMode());
			 }else if (code == Keyboard.SHIFT){
				 _modifiers["constrain size"] = true;
			 }else
			 if (code == Keys.G){
				_modifiers["grid snapping"] = !_modifiers["grid snapping"];
			 }else if (code == Keyboard.DOWN){
				 moveAll(0,1);
			 }else if (code == Keyboard.UP){
				  moveAll(0,-1);
			 }else if (code == Keyboard.LEFT){
				   moveAll(-1,0);
			 }else if (code == Keyboard.RIGHT){
			       moveAll(1,0);
			 }else
			 if (code == Keys.X){
				
				// trace("delete")
				 if (_shape){
					_shape.parent.removeChild(_shape); 
				 }
			 }
			 
			 
			 if (_current.mode.toString() == "Poly"){
				if (code == Keyboard.SPACE){
					 _current.mode.reset();
				}
			 }
		}
		private function moveAll(offX:Number, offY:Number):void{
			 for (var i:int = 0; i<_main.numChildren; i++){
				    var e:CreatorObject = _main.getChildAt(i) as CreatorObject;
					if (e){
						e.x += offX;
						e.y += offY
					}
				 }
		}
		private function readCodeFromObjects():String{
			var str:String = "";
			for (var i:int = 0; i<_main.numChildren; i++){
				var e:CreatorObject = _main.getChildAt(i) as CreatorObject;
				if (e){
					if (!(e is JointObject)){
					   str += e.objectDef + "\n";
				    }
				}
			}
			str += "// joints:\n";
			for (i = 0; i<_main.numChildren; i++){
				e = _main.getChildAt(i) as CreatorObject;
				if (e){
					if ((e is JointObject)){
					   str += e.objectDef + "\n";
				    }
				}
			}
			
			
			trace(str);
			return str;
		}
		
		private function onKeyReleased(evt:KeyboardEvent):void{
			 var code:int = evt.keyCode;
			 if (code == Keyboard.SHIFT){
			    _modifiers["constrain size"] = false;
			 } 
		     
		}
		
	}
}