﻿package com.actionsnippet.qbox.editor.modes{
	
	import com.actionsnippet.qbox.editor.*;
	
	import flash.display.*
	import flash.events.*;
	import flash.utils.*;
	import flash.geom.*;
	
	public class BoxMode extends DrawingMode {
	    private var _box:CreatorObject;
		
		public function BoxMode(){
		}
		
		override public function start(app:DrawingCreator):void{
			
			 trace("box start");
			 _app = app;
			 _box =  new BoxObject();
			 if (_app.modifiers["grid snapping"]){
				 _box.x = int(_app.main.mouseX / 10) * 10;
				 _box.y = int(_app.main.mouseY / 10) * 10;
			 }else{
			 _box.x = _app.main.mouseX;
			 _box.y = _app.main.mouseY;
			 }
			 
			 _app.main.addChild(_box);
			 _box.dispatchEvent(new Event("created",true));
		}
		
		override public function run():void{
			 _box.graphics.clear();
			 _box.graphics.lineStyle(0, 0x000000);
			 _box.graphics.beginFill(0xCCCCCC);
			 var dx:Number =  _app.main.mouseX - _box.x;
			 var dy:Number =  _app.main.mouseY- _box.y;
			 if (_app.modifiers["grid snapping"]){
				  dx = int(dx / 10) * 10;
				  dy = int(dy / 10) * 10;
			 }
			 if (_app.modifiers["constrain size"]){
				dy = dx; 
			 }
			  _box.graphics.drawRect(0, 0, dx, dy);
		}
		
		 
		override public function end():void{
			trace("box end");
			var w:Number = _box.width;
			var h:Number = _box.height;
			if (w == 0 || h == 0){
				_box.parent.removeChild(_box);
				return;
			}
			_box.shapeData.width = w;
			_box.shapeData.height = h;
			var b:Rectangle= _box.getRect(_box.parent);
			var nx:Number = b.left + _box.width / 2;
			var ny:Number = b.top + _box.height / 2;
			 _box.graphics.clear();
			 _box.graphics.lineStyle(0, 0x000000);
			 _box.graphics.beginFill(0xCCCCCC);
			 _box.graphics.drawRect(-w/2, -h/2, w, h);
			 _box.x = nx;
			 _box.y = ny;
		}
		 
		
		override public function toString():String {
			return "Box";
		}
		 
	}
}