﻿package com.actionsnippet.qbox.editor.modes{
	
	import com.actionsnippet.qbox.editor.*;
	import com.actionsnippet.parsers.ASObject;
	
	import flash.net.*;
	import flash.events.*;
	
    
	public class LoadMode implements IDrawMode {
		
		protected var _app:DrawingCreator;
		private var file:FileReference;
		private var _data:String;
		public function LoadMode(app:DrawingCreator){
			_app = app;
			file = new FileReference();
			file.browse();
			file.addEventListener(Event.SELECT, onSelected);
		}
		private function onSelected(evt:Event):void{
			trace("SELECTED", file.name);
			file.load();
			file.addEventListener(Event.COMPLETE, onComplete);
		}
		private function onComplete(evt:Event):void {
			_data = String(file.data);
			parse();
		}
		private function parse():void{
			var shape:CreatorObject;
			var lines:Array = new Array();
			lines = _data.split(";");
			for (var i:int = 0; i<lines.length; i++){
				//trace(i, "-->", lines[i]);
				// see if there is a variable name
				var nameDef:String = "";
				if (lines[i].indexOf("var")!=-1){
					nameDef = lines[i].match(/var\s+[a-z, A-Z,0-9].+\:QuickObject/);
					nameDef = nameDef.replace(/var\s+/, "");
					nameDef = nameDef.replace(/\:QuickObject/, "");
					trace(nameDef);
				}
				
				// get the object definition:
				var objString:String = lines[i].match(/\{.*\}/);
				// see if there are any box definitions and create BoxObject() instances accordinly
				if (lines[i].indexOf("addBox") != -1){
					shape = new BoxObject();
				}else if (lines[i].indexOf("addCircle") != -1){
					shape = new CircleObject();
				}else if (lines[i].indexOf("addPoly") != -1){
					shape = new PolyObject();
				}else if (lines[i].indexOf("addJoint") != -1){
					shape = new JointObject();
				}
				// tell the current shape instance to create itself
				//trace("///////////");
				if (objString != null){ 
					shape.createFromObject(nameDef, ASObject.parse(objString));
					_app.main.addChild(shape);
				}
				//trace("!---------------");
			}
			
		}
		
		public function start(app:DrawingCreator):void{
			
		}
		
		public function run():void{
			
		}
		
		public function end():void{
			trace("end");
		}
		public function reset():void{
		}
		public function toString():String{
			return "Default";
		}
		
		 
	}
}